//////////////////////////////////////////////////////////////////////
// Follow.cpp
// -------------------------------------------------------------------
// This module will make the character follow another player
//
// The modules are event based, and the functions they export will be
// called by the D2HackIt! dll at appropriate times. Any events you do
// not need can safely be deleted from this file, as D2HackIt! only
// calls the events it can bind.
//
// incorporating code from SHOPBOT (ackmed) and CHICKEN (maulei)
//
// Optimal Genes
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Global stuff.
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////

//------------------------------------------------//
// includes
//------------------------------------------------//
#include "External\ClientCore.cpp"
#include "follow.h"

//------------------------------------------------//
// Variables
//------------------------------------------------//


WORD Debug;
char DebugBuffer[1024];
BOOL inGame = false;        // d2hackit bug/feature work around

GATEWAYSTRUCT last_gw;
GATEWAYSTRUCT arrPortals[TP_ARRAY_SIZE];
int arrP_count = 0;
GATEWAYSTRUCT gateway[] = {
	//{0,"Town portal",	{0,0},0x003b,	"Portal"},
	{0,"Permanent town portal",	{0,0},0x003c,	"Portal"},
	{0,"Portal to Duriel's Lair",	{0,0},0x0064,	"Duriel's Lair"},
	{0,"arcane sanctuary portal",	{0,0},0x012a,	"portal"},
	{0,"hellgate",	{0,0},0x0156,	"portal"},
	{0,"Portal to next guild level",	{0,0},0x0179,	"Guild Portal"},
	{0,"baals portal",	{0,0},0x0233,	"The Worldstone Chamber"},
	{0,"last portal",	{0,0},0x0235,	"strlastcinematic"},
	{0,"baals portal",	{0,0},0x0239,	"Throne of Destruction"}
};

NPCHEALERSTRUCT healer[] = {
	//Name,BaseId,PopulateId
	{"Akara",34,148},
	{"Fara",52,178},
	{"ormus",96,255},
	{"Jamella",189,405},
	{"Malah",232,77}
};

char	*cmd_gofield,		// for user defined values in ini
		*cmd_rettown,
		*cmd_stay,
		*cmd_follow,
		*cmd_attack,
		*cmd_taketp,
		*cmd_switch,
		*cmd_waypoint,
		*cmd_weaponswitch,
		*cmd_heal;

PLAYERINGAME playerInGame[MAX_PLAYER_IN_GAME];	// store player name & id in current game
LVL_WRAP_INFO lvl_entrance[LVL_ARRAY_SIZE];     // store location & id of cave/lvl entrances
PORTALINFO portals[TP_ARRAY_SIZE];		        // info about town portal from leader
WPSTRUCT	wp;             // store the last wp encountered
THISGAMESTRUCT *thisgame;   // pointer to current game
LOCATIONSTRUCT leaderLoc;	// location of leader

                                // TODO: below to be moved into portals[]
//BYTE portalPosInTown[4];		// my tp pos in town, for returning to field
BYTE portalPos[4];              // my tp pos in field
BYTE saPacket[9];               // go in TP packet

DWORD stateGotoTown;            // current state of follower
bool toFollow = false;			// flag to follow other play or not
bool toAttack = false;			// flag to attack monster or not
bool blockSync = false;			// flag to block sync msg
bool autoDrink = false;         // flag to auto drink potion or not
bool autoBuy   = false;         // flag to auto buy potions/arrows/etc
bool autoRepair = false;        // flag to auto repair all
bool autoResurr = true;			// flag to auto resurr after death
bool justDied = false;			// flag to suspend action when bot just died
bool toNotify = true;			// flat to notify master via overhead msg
bool toTeleport;				// flag to teleport with master or not
bool shiftState = false;		// shift attack or not
int attackSkill = STATE_SKILL_LEFT; // flag to control which skill to use for attack

int autoAttack = STATE_ATK_DEFENSIVE;	// flag to control auto attack monster
int StateInParty = 0;           // party flag
DWORD leaderId = 0;				// ID of the player to follow
char leaderName[16];				// string contains master name (for ini or command start)
int leaderPos = -1;			    // index of player to follow in playerInGame array
int CurrentHP, CurrentMP;       // HP, MP monitor
int portal_count = 0;
int lastHealer_seen = -1;			// index to the last heal bot sees, 0 - act1, 1 - act 2, etc

//////////////////////////////////////////////////////////////////////
// CLIENTINFO
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
CLIENTINFO
(		
	0,2,							// Module version (Major, Minor)
	"Optimal Genes",				// Author
	"www.geocities.com/optimal_genes/follow.html",	// url (http:// is appended)
	"Follow module - Follow Another Player.",	// Short module description
	"optimal_genes@yahoo.com.au"				// Author eMail
)

//////////////////////////////////////////////////////////////////////
// MODULECOMMANDSTRUCT ModuleCommands[]
// -------------------------------------------------------------------
// The "usage" line can contain "\n" as linebreaks and should be in 
// the following format for consistency:
//
// "commandname <required parameter> [optional parameter]c0 Description"
//////////////////////////////////////////////////////////////////////

MODULECOMMANDSTRUCT ModuleCommands[]=
{
	{	// The 'help' command is implemented in ClientCore.cpp and 
		// should not need to be changed.
		"help",
		OnGameCommandHelp,
		"helpc0 List commands available in this module.\n"
		"<command> helpc0 Shows detailed help for <command> in this module."
	},

	// Add your own commands here
	{
		"list",
		OnGameCommandList,
		"Display Player id"
	},
    {
        "start",
        OnGameCommandStart,
		"start c3playerIDc4"
        " - start following the given player, use .follow info to get c3playerID"
    },
    {
        "stop",
        OnGameCommandStop,
        "stop - stop following a player"
    },
    {
        "attack",
        OnGameCommandAttack,
        "attack - Toggle follow bot Attacking mode"
    },
    {
        "auto",
        OnGameCommandAuto,
		"auto [ON|OFF]- Set follow bot Auto Attacking mode\n"
		"auto ON - Set follow bot Auto Attacking mode\n"
		"auto OFF - Turn off Auto Attacking mode"
    },
    {
        "shift",
        OnGameCommandShift,
		"shift - toggle shift(attack) State"
    },
    {
        "block",
        OnGameCommandBlock,
		"block server sync (toggle)"
    },
    {
        "notify",
        OnGameCommandNotify,
		"toggle Overhead notify"
    },
	{
        "status",
        OnGameCommandStatus,
        "Show Current Follow Module Status"
    },
    {
        "reload",
        OnGameCommandReload,
		"reload ini file"
    },
    {
        "save",
        OnGameCommandSave,
		"Save bot states to ini file"
    },
	{	
		"debug",
		OnCommandDebug,
		"c4debugc0 [devel|packet] toggle debug mode.\n"
		"[devel] adds extra debugging\n"
		"[packet] adds packet level debugging"
	},
	{NULL}	// No more commands
};


//////////////////////////////////////////////////////////////////////
// PACKETCOMMANDSTRUCT PacketCmd[]
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
PACKETCOMMANDSTRUCT PacketCmd[] =
{
	//--------- Receive --------
	{
        0x0f,
        false,
        player_movement,
        "player movement"
    },
	{
        0x4d,
        false,
        player_nontarget_attack,
        "player_nontarget_attack"
    },
	{
        0x4c,
        false,
        player_target_attack,
        "player_target_attack"
    },
	{
        0x68,
        false,
        monster_approaching,
        "monster_approaching"
    },
	{
        0x67,
        false,
        monster_moving,
        "monster_moving"
    },
//{
 //       0x6c,
 //       false,
 //       monster_attacking,
 //       "monster_attacking"
 //   },
	{
        0x10,
        false,
        cave_follow,
        "cave_follow"
    },
	{
        0x0d,
        false,
        player_info,
        "player_info"
    },
	{
        0x82,
        false,
        townportal_info,
        "townportal_info"
    },
	{
        0x7f,
        false,
        posUpdate,
        "position update"
    },
 // {
 //       0x09,
 //       false,
 //       cave_notification,
 //       "cave_notification"
 // },
	{
        0x5b,
        false,
        player_join,
        "player_join"
    },
	{
        0x59,
        false,
        new_player,
        "new_player"
    },
	{
        0x5a,
        false,
        player_notification,
        "player_notification"
    },
	{
        0x26,
        false,
        incoming_chat_msg,
        "incoming_chat_msg"
    },
	{
        0x23,
        false,
        skill_selected,
        "skill_selected"
    },
	{
        0x55,
        false,
        healer_info,
        "healer_info"
    },
	//--------- Send ----------
    {
        0x03,
        true,
        client_walk_update,
        "Client walk update"
    },
    {
        0x5f,
        true,
        deny_client_sync,
        "Deny client sync with server"
    },
 // {
 //       0x,
 //       false,
 //       ,
 //       ""
 //   },
    {NULL}
};

//////////////////////////////////////////////////////////////////////
// FindPacketCommand
// -------------------------------------------------------------------
// locate the method to execute for a particular packet Id
//////////////////////////////////////////////////////////////////////
PACKETCOMMANDSTRUCT* PRIVATE FindPacketCommand(byte packetId, BOOL send)
{
	PACKETCOMMANDSTRUCT* pcs = PacketCmd;
	while (pcs->bPacket) {
		if ((pcs->bPacket == packetId) && (pcs->isSendPacket == send))
			return pcs;
		pcs++;
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////
// OnClientStart
// -------------------------------------------------------------------
// Runs *once* when the module loads. 
// initialization code here.
//
// Return FALSE to prevent module from loading.
//////////////////////////////////////////////////////////////////////
BOOL EXPORT OnClientStart()
{
	toFollow = false;
	for (int i = 0; i < MAX_PLAYER_IN_GAME; i++)
		playerInGame[i].InUse = false;

	readInitFile();
    //OnGameCommandStatus(NULL, 0);
	return TRUE;
}


//////////////////////////////////////////////////////////////////////
// OnClientStop
// -------------------------------------------------------------------
// Runs *once* before client is unloaded. 
// cleanup code here.
//
// Return value should be TRUE.
//////////////////////////////////////////////////////////////////////
BOOL EXPORT OnClientStop()
{
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// EVENTS
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// OnGamePacketBeforeSent ********************************************
// -------------------------------------------------------------------
// Executes before packets are sent from the game to the server.
// 
// If you rewrite the packet, you must make sure to return the length
// of the new packet!
//
// NOTE: This event also works in single player games.
//////////////////////////////////////////////////////////////////////
DWORD EXPORT OnGamePacketBeforeSent(BYTE* aPacket, DWORD aLen)
{
	//------------------------------------------------//
	// dump packet if packet debugging is on
	if(Debug == DEBUG_PACKET)
	{
		sprintf(DebugBuffer,"SENT: ");
		for(DWORD i = 0; i < aLen; i++)
		{
			sprintf(DebugBuffer,"%s %.2x",DebugBuffer,aPacket[i]);
		}
		server->GamePrintInfo(DebugBuffer);
	}

	//------------------------------------------------//
	// locate packet command to execute
    PACKETCOMMANDSTRUCT *pcs;
    pcs = FindPacketCommand(aPacket[0], true);
    if (pcs)
    {
        DWORD rLen;
        rLen = pcs->pFunc(aPacket, aLen);
		return rLen;
    }

	return aLen;
}

//////////////////////////////////////////////////////////////////////
// OnGamePacketBeforeReceived ****************************************
// -------------------------------------------------------------------
// Executes before packets are received to the game from the server.
// 
// If you rewrite the packet, you must make sure to return the length
// of the new packet!
//
// NOTE: This event also works in single player games.
//////////////////////////////////////////////////////////////////////
DWORD EXPORT OnGamePacketBeforeReceived(BYTE* aPacket, DWORD aLen)
{
	//------------------------------------------------//
	// dump packet if packet debugging is on
	if (Debug == DEBUG_PACKET)
	{
		sprintf(DebugBuffer,"%s","RECV: ");
		for(DWORD i = 0;i < aLen;i++)
			sprintf(DebugBuffer,"%s %.2x",DebugBuffer,aPacket[i]);

		server->GamePrintInfo(DebugBuffer);
	}

	//------------------------------------------------//
	// locate packet command to execute
    PACKETCOMMANDSTRUCT *pcs;
    pcs = FindPacketCommand(aPacket[0], false);
    if (pcs)
    {
        DWORD rLen;
        rLen = pcs->pFunc(aPacket, aLen);
		return rLen;
    }
	//------------------------------------------------//
	// Packet 51 02 - world entity update
	///////////////////////
	if ( (aPacket[0] == 0x51) && 
		 (aPacket[1] == 0x02) )
	{
    	//------------------------------------------------//
    	//  3b 00 - town portal
		if (stateGotoTown == STATE_GOTO_TOWN_USING_SKILL && 
			(aPacket[6] == 0x3b) && 
			(aPacket[7] == 0x00))
		{
        	//	Portal appears, walk into it
			walkInPortal(aPacket, aLen);
			return aLen;
		}
    	//------------------------------------------------//
		// WayPoint (call fn to check since there are 16 different id's
		WORD lid;
		memcpy(&lid,&aPacket[6],2);
		if(isWP(lid))
		{
			memcpy(&wp.pos.x,&aPacket[8],2);
			memcpy(&wp.pos.y,&aPacket[10],2);
			memcpy(&wp.entityID,&aPacket[2],4);
			wp.lid = lid;
			// should fill in position at some point.
			
            if(Debug == DEBUG_DEVEL)
    		{
				sprintf(DebugBuffer,"wp id: %d (%d,%d) lid:%.4x",wp.entityID,wp.pos.x,wp.pos.y,wp.lid);
				server->GamePrintInfo(DebugBuffer);
			}
			return aLen;
		} 
    	//------------------------------------------------//
    	//  gateways
		else if (isGateWay(lid))
		{
			memcpy(&last_gw.pos.x,&aPacket[8],2);
			memcpy(&last_gw.pos.y,&aPacket[10],2);
			memcpy(&last_gw.entityID,&aPacket[2],4);
			last_gw.lid = lid;

			// update stored gateway info
			arrPortals[arrP_count].lid = lid;
			memcpy(&arrPortals[arrP_count].entityID,&aPacket[2],4);
			memcpy(&arrPortals[arrP_count].pos.x,&aPacket[8],2);
			memcpy(&arrPortals[arrP_count].pos.y,&aPacket[10],2);
            if(Debug == DEBUG_DEVEL)
    		{
				sprintf(DebugBuffer,"gateway(%d) id: %d (%d,%d) lid:%.4x", arrP_count, arrPortals[arrP_count].entityID,
						arrPortals[arrP_count].pos.x, arrPortals[arrP_count].pos.y, arrPortals[arrP_count].lid);
				server->GamePrintInfo(DebugBuffer);
			}
			arrP_count = (arrP_count + 1) % TP_ARRAY_SIZE;


			//print_Packet(aPacket, aLen);
			return aLen;
		}
	}
	return aLen;
}

//////////////////////////////////////////////////////////////////////
// OnGameTimerTick
// -------------------------------------------------------------------
// This gets executed apx. every 1/10th of a second when in a game.
//
// You can use this to create custom timers.
//////////////////////////////////////////////////////////////////////
DWORD EXPORT OnGameTimerTick(void)
{
	// d2hackit bug/feature work around
	// OnGameTimerTick() is called even while outside of a game
	// this can lead to diablo crashing.
	if(!inGame)
		return true;

	return 0;
}


//////////////////////////////////////////////////////////////////////
// OnCommand Debug - standard debugging toggle in most modules
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////

BOOL PRIVATE OnCommandDebug(char **argv, int argc)
{
	// no params passed, just do a simple toggle
	if(argc == 2){
		if(Debug) {
			server->GamePrintString("Debugging disabled");
			Debug = DEBUG_OFF;
		} else {
			server->GamePrintString("Debugging enabled");
			Debug = DEBUG_USER;
		}
		return true;
	} else if(argc == 3) {
		if(strcmpi(argv[2],"devel") == 0) {
			server->GamePrintString("Devel Debugging enabled");
			Debug = DEBUG_DEVEL;
			return true;
		} else if(strcmpi(argv[2],"packet") == 0) {
			server->GamePrintString("Packet Debugging enabled");
			Debug = DEBUG_PACKET;
			return true;
		}
	}
	return false;
}


//////////////////////////////////////////////////////////////////////
// isGateWay
// -------------------------------------------------------------------
// identify if the object is considered as a gateway(blue/red portals)
//////////////////////////////////////////////////////////////////////
BOOL isGateWay(WORD lid) 
{
	for(int i = 0; i < GATEWAY_COUNT; i++)
	{
		if(lid == gateway[i].lid)
		{
			sprintf(DebugBuffer,"%s", gateway[i].name1);
			server->GamePrintInfo(DebugBuffer);
			return true;
		}
	}
	return false;
}

//////////////////////////////////////////////////////////////////////
// print_Packet
// -------------------------------------------------------------------
// for debugging purposes
//////////////////////////////////////////////////////////////////////
void print_Packet(BYTE* aPacket, DWORD aLen)
{
	sprintf(DebugBuffer,"P: ");
	for(DWORD i = 0; i < aLen; i++)
	{
		sprintf(DebugBuffer,"%s %.2x",DebugBuffer,aPacket[i]);
	}
	server->GamePrintInfo(DebugBuffer);
}


