// skills.h
// optimal_genes

typedef struct skill_t {
	char			name[64];
	WORD			skillID;
	char			class[5];
	bool			is_aura;
	int				cast_delay;
	bool			no_left_skill; // 0 - either side, 1 - right only
	bool			is_castable_intown;
	bool			is_passive;
} SKILLSTRUCT;

SKILLSTRUCT game_skills[] = 
{
	//skill,	Id,	charclass,	isaura,	Delay,	leftskl,	InTown,	P"ass"ive
	{"Attack",			0,	"all",	0,	0,	0,	0,	0},
	{"Kick",			1,	"all",	0,	0,	0,	0,	0},
	{"Throw",			2,	"all",	0,	0,	0,	0,	0},
	{"Unsummon",		3,	"all",	0,	0,	0,	1,	0},
	{"Left Hand Throw",	4,	"all",	0,	0,	0,	0,	0},
	{"Left Hand Swing",	5,	"all",	0,	0,	0,	0,	0},
	{"Magic Arrow",		6,	"ama",	0,	0,	0,	0,	0},
	{"Fire Arrow",		7,	"ama",	0,	0,	0,	0,	0},
	{"Inner Sight",		8,	"ama",	0,	0,	1,	0,	0},
	{"Critical Strike",	9,	"ama",	0,	0,	1,	0,	1},
	{"Jab",				10,	"ama",	0,	0,	0,	0,	0},
	{"Cold Arrow",		11,	"ama",	0,	0,	0,	0,	0},
	{"Multiple Shot",	12,	"ama",	0,	0,	0,	0,	0},
	{"Dodge",			13,	"ama",	0,	0,	1,	0,	1},
	{"Power Strike",	14,	"ama",	0,	0,	0,	0,	0},
	{"Poison Javelin",	15,	"ama",	0,	0,	0,	0,	0},
	{"Exploding Arrow",	16,	"ama",	0,	0,	0,	0,	0},
	{"Slow Missiles",	17,	"ama",	0,	0,	1,	0,	0},
	{"Avoid",			18,	"ama",	0,	0,	1,	0,	1},
	{"Impale",			19,	"ama",	0,	0,	0,	0,	0},
	{"Lightning Bolt",	20,	"ama",	0,	0,	0,	0,	0},
	{"Ice Arrow",		21,	"ama",	0,	0,	0,	0,	0},
	{"Guided Arrow",	22,	"ama",	0,	0,	0,	0,	0},
	{"Penetrate",		23,	"ama",	0,	0,	1,	0,	1},
	{"Charged Strike",	24,	"ama",	0,	0,	0,	0,	0},
	{"Plague Javelin",	25,	"ama",	0,	100,	0,	0,	0},
	{"Strafe",			26,	"ama",	0,	0,	0,	0,	0},
	{"Immolation Arrow",	27,	"ama",	0,	25,	0,	0,	0},
	{"Decoy",			28,	"ama",	0,	0,	1,	0,	0},
	{"Evade",			29,	"ama",	0,	0,	1,	0,	1},
	{"Fend",			30,	"ama",	0,	0,	0,	0,	0},
	{"Freezing Arrow",	31,	"ama",	0,	0,	0,	0,	0},
	{"Valkyrie",		32,	"ama",	0,	0,	1,	1,	0},
	{"Pierce",			33,	"ama",	0,	0,	1,	1,	1},
	{"Lightning Strike",	34,	"ama",	0,	0,	0,	0,	0},
	{"Lightning Fury",	35,	"ama",	0,	0,	0,	0,	0},
	{"Fire Bolt",		36,	"sor",	0,	0,	0,	0,	0},
	{"Warmth",			37,	"sor",	0,	0,	1,	1,	1},
	{"Charged Bolt",	38,	"sor",	0,	0,	0,	0,	0},
	{"Ice Bolt",		39,	"sor",	0,	0,	0,	0,	0},
	{"Frozen Armor",	40,	"sor",	0,	0,	1,	1,	0},
	{"Inferno",			41,	"sor",	0,	0,	0,	0,	0},
	{"Static Field",	42,	"sor",	0,	0,	1,	0,	0},
	{"Telekinesis",		43,	"sor",	0,	0,	1,	1,	0},
	{"Frost Nova",		44,	"sor",	0,	0,	1,	0,	0},
	{"Ice Blast",		45,	"sor",	0,	0,	0,	0,	0},
	{"Blaze",			46,	"sor",	0,	0,	1,	0,	0},
	{"Fire Ball",		47,	"sor",	0,	0,	0,	0,	0},
	{"Nova",			48,	"sor",	0,	0,	1,	0,	0},
	{"Lightning",		49,	"sor",	0,	0,	0,	0,	0},
	{"Shiver Armor",	50,	"sor",	0,	0,	1,	1,	0},
	{"Fire Wall",		51,	"sor",	0,	35,	1,	0,	0},
	{"Enchant",			52,	"sor",	0,	0,	1,	1,	0},
	{"Chain Lightning",	53,	"sor",	0,	0,	0,	0,	0},
	{"Teleport",		54,	"sor",	0,	0,	1,	0,	0},
	{"Glacial Spike",	55,	"sor",	0,	0,	0,	0,	0},
	{"Meteor",			56,	"sor",	0,	30,	1,	0,	0},
	{"Thunder Storm",	57,	"sor",	0,	0,	1,	0,	0},
	{"Energy Shield",	58,	"sor",	0,	0,	1,	1,	0},
	{"Blizzard",		59,	"sor",	0,	45,	1,	0,	0},
	{"Chilling Armor",	60,	"sor",	0,	0,	1,	1,	0},
	{"Fire Mastery",	61,	"sor",	0,	0,	1,	0,	1},
	{"Hydra",			62,	"sor",	0,	50,	1,	0,	0},
	{"Lightning Mastery",	63,	"sor",	0,	0,	1,	0,	1},
	{"Frozen Orb",		64,	"sor",	0,	25,	0,	0,	0},
	{"Cold Mastery",	65,	"sor",	0,	0,	1,	0,	1},
	{"Amplify Damage",	66,	"nec",	0,	0,	1,	0,	0},
	{"Teeth",			67,	"nec",	0,	0,	0,	0,	0},
	{"Bone Armor",		68,	"nec",	0,	0,	1,	1,	0},
	{"Skeleton Mastery",	69,	"nec",	0,	0,	1,	0,	1},
	{"Raise Skeleton",	70,	"nec",	0,	0,	1,	0,	0},
	{"Dim Vision",		71,	"nec",	0,	0,	1,	0,	0},
	{"Weaken",			72,	"nec",	0,	0,	1,	0,	0},
	{"Poison Dagger",	73,	"nec",	0,	0,	0,	0,	0},
	{"Corpse Explosion",	74,	"nec",	0,	0,	1,	0,	0},
	{"Clay Golem",		75,	"nec",	0,	0,	1,	1,	0},
	{"Iron Maiden",		76,	"nec",	0,	0,	1,	0,	0},
	{"Terror",			77,	"nec",	0,	0,	1,	0,	0},
	{"Bone Wall",		78,	"nec",	0,	0,	1,	0,	0},
	{"Golem Mastery",	79,	"nec",	0,	0,	1,	0,	1},
	{"Raise Skeletal Mage",	80,	"nec",	0,	0,	1,	0,	0},
	{"Confuse",			81,	"nec",	0,	0,	1,	0,	0},
	{"Life Tap",		82,	"nec",	0,	0,	1,	0,	0},
	{"Poison Explosion",	83,	"nec",	0,	0,	1,	0,	0},
	{"Bone Spear",		84,	"nec",	0,	0,	0,	0,	0},
	{"BloodGolem",		85,	"nec",	0,	0,	1,	1,	0},
	{"Attract",			86,	"nec",	0,	0,	1,	0,	0},
	{"Decrepify",		87,	"nec",	0,	0,	1,	0,	0},
	{"Bone Prison",		88,	"nec",	0,	0,	1,	0,	0},
	{"Summon Resist",	89,	"nec",	0,	0,	1,	0,	1},
	{"IronGolem",		90,	"nec",	0,	0,	1,	1,	0},
	{"Lower Resist",	91,	"nec",	0,	0,	1,	0,	0},
	{"Poison Nova",		92,	"nec",	0,	0,	1,	0,	0},
	{"Bone Spirit",		93,	"nec",	0,	0,	0,	0,	0},
	{"FireGolem",		94,	"nec",	0,	0,	1,	1,	0},
	{"Revive",			95,	"nec",	0,	0,	1,	0,	0},
	{"Sacrifice",		96,	"pal",	0,	0,	0,	0,	0},
	{"Smite",			97,	"pal",	0,	0,	0,	0,	0},
	{"Might",			98,	"pal",	1,	0,	1,	1,	0},
	{"Prayer",			99,	"pal",	1,	0,	1,	1,	0},
	{"Resist Fire",		100,	"pal",	1,	0,	1,	1,	0},
	{"Holy Bolt",		101,	"pal",	0,	0,	0,	0,	0},
	{"Holy Fire",		102,	"pal",	1,	0,	1,	1,	0},
	{"Thorns",			103,	"pal",	1,	0,	1,	1,	0},
	{"Defiance",		104,	"pal",	1,	0,	1,	1,	0},
	{"Resist Cold",		105,	"pal",	1,	0,	1,	1,	0},
	{"Zeal",			106,	"pal",	0,	0,	0,	0,	0},
	{"Charge",			107,	"pal",	0,	0,	0,	0,	0},
	{"Blessed Aim",		108,	"pal",	1,	0,	1,	1,	0},
	{"Cleansing",		109,	"pal",	1,	0,	1,	1,	0},
	{"Resist Lightning",	110,	"pal",	1,	0,	1,	1,	0},
	{"Vengeance",		111,	"pal",	0,	0,	0,	0,	0},
	{"Blessed Hammer",	112,	"pal",	0,	0,	0,	0,	0},
	{"Concentration",	113,	"pal",	1,	0,	1,	1,	0},
	{"Holy Freeze",		114,	"pal",	1,	0,	1,	1,	0},
	{"Vigor",		115,	"pal",	1,	0,	1,	1,	0},
	{"Conversion",	116,	"pal",	0,	0,	0,	0,	0},
	{"Holy Shield",	117,	"pal",	0,	0,	1,	1,	0},
	{"Holy Shock",	118,	"pal",	1,	0,	1,	1,	0},
	{"Sanctuary",	119,	"pal",	1,	0,	1,	1,	0},
	{"Meditation",	120,	"pal",	1,	0,	1,	1,	0},
	{"Fist of the Heavens",	121,	"pal",	0,	25,	0,	0,	0},
	{"Fanaticism",	122,	"pal",	1,	0,	1,	1,	0},
	{"Conviction",	123,	"pal",	1,	0,	1,	1,	0},
	{"Redemption",	124,	"pal",	1,	0,	1,	1,	0},
	{"Salvation",	125,	"pal",	1,	0,	1,	1,	0},
	{"Bash",		126,	"bar",	0,	0,	0,	0,	0},
	{"Sword Mastery",	127,	"bar",	0,	0,	1,	0,	2},
	{"Axe Mastery",	128,	"bar",	0,	0,	1,	0,	2},
	{"Mace Mastery",	129,	"bar",	0,	0,	1,	0,	2},
	{"Howl",		130,	"bar",	0,	0,	1,	0,	0},
	{"Find Potion",	131,	"bar",	0,	0,	1,	0,	0},
	{"Leap",		132,	"bar",	0,	0,	0,	0,	0},
	{"Double Swing",	133,	"bar",	0,	0,	0,	0,	0},
	{"Pole Arm Mastery",	134,	"bar",	0,	0,	1,	0,	2},
	{"Throwing Mastery",	135,	"bar",	0,	0,	1,	0,	2},
	{"Spear Mastery",	136,	"bar",	0,	0,	1,	0,	2},
	{"Taunt",			137,	"bar",	0,	0,	1,	0,	0},
	{"Shout",			138,	"bar",	0,	0,	1,	0,	0},
	{"Stun",			139,	"bar",	0,	0,	0,	0,	0},
	{"Double Throw",	140,	"bar",	0,	0,	0,	0,	0},
	{"Increased Stamina",	141,	"bar",	0,	0,	1,	0,	1},
	{"Find Item",	142,	"bar",	0,	0,	1,	0,	0},
	{"Leap Attack",	143,	"bar",	0,	0,	0,	0,	0},
	{"Concentrate",	144,	"bar",	0,	0,	0,	0,	0},
	{"Iron Skin",	145,	"bar",	0,	0,	1,	0,	1},
	{"Battle Cry",	146,	"bar",	0,	0,	1,	0,	0},
	{"Frenzy",		147,	"bar",	0,	0,	0,	0,	0},
	{"Increased Speed",	148,	"bar",	0,	0,	1,	0,	1},
	{"Battle Orders",	149,	"bar",	0,	0,	1,	0,	0},
	{"Grim Ward",		150,	"bar",	0,	0,	1,	0,	0},
	{"Whirlwind",		151,	"bar",	0,	0,	0,	0,	0},
	{"Berserk",			152,	"bar",	0,	0,	0,	0,	0},
	{"Natural Resistance",	153,	"bar",	0,	0,	1,	0,	1},
	{"War Cry",			154,	"bar",	0,	0,	1,	0,	0},
	{"Battle Command",	155,	"bar",	0,	0,	1,	0,	0},
	{"Scroll of Townportal",	219,	"all",	0,	0,	0,	0,	0},
	{"Book of Townportal",	220,	"all",	0,	0,	0,	0,	0},
	{"Raven",			221,	"dru",	0,	0,	1,	1,	0},
	{"Poison Creeper",	222,	"dru",	0,	0,	1,	1,	0},
	{"Wearwolf",		223,	"dru",	0,	25,	1,	1,	0},
	{"Shape Shifting",	224,	"dru",	0,	0,	0,	0,	1},
	{"Firestorm",		225,	"dru",	0,	15,	0,	0,	0},
	{"Oak Sage",		226,	"dru",	0,	0,	1,	1,	0},
	{"Summon Spirit Wolf",	227,	"dru",	0,	0,	1,	1,	0},
	{"Wearbear",		228,	"dru",	0,	25,	1,	1,	0},
	{"Molten Boulder",	229,	"dru",	0,	50,	0,	0,	0},
	{"Arctic Blast",	230,	"dru",	0,	0,	0,	0,	0},
	{"Carrion Vine",	231,	"dru",	0,	0,	1,	1,	0},
	{"Feral Rage",		232,	"dru",	0,	0,	0,	0,	0},
	{"Maul",			233,	"dru",	0,	0,	0,	0,	0},
	{"Fissure",			234,	"dru",	0,	50,	1,	0,	0},
	{"Cyclone Armor",	235,	"dru",	0,	0,	1,	1,	0},
	{"Heart of Wolverine",	236,	"dru",	0,	0,	1,	1,	0},
	{"Summon Dire Wolf",	237,	"dru",	0,	0,	1,	1,	0},
	{"Rabies",		238,	"dru",	0,	0,	0,	0,	0},
	{"Fire Claws",	239,	"dru",	0,	0,	0,	0,	0},
	{"Twister",		240,	"dru",	0,	0,	0,	0,	0},
	{"Solar Creeper",	241,	"dru",	0,	0,	1,	1,	0},
	{"Hunger",		242,	"dru",	0,	0,	0,	0,	0},
	{"Shock Wave",	243,	"dru",	0,	0,	0,	0,	0},
	{"Volcano",		244,	"dru",	0,	100,	1,	0,	0},
	{"Tornado",		245,	"dru",	0,	0,	0,	0,	0},
	{"Spirit of barbs",	246,	"dru",	0,	0,	1,	1,	0},
	{"Summon Grizzly",	247,	"dru",	0,	0,	1,	1,	0},
	{"Fury",		248,	"dru",	0,	0,	0,	0,	0},
	{"Armageddon",	249,	"dru",	0,	150,	1,	0,	0},
	{"Hurricane",	250,	"dru",	0,	150,	1,	0,	0},
	{"Fire Blast",	251,	"ass",	0,	0,	0,	0,	0},
	{"Claw Mastery",	252,	"ass",	0,	0,	0,	0,	1},
	{"Psychic Hammer",	253,	"ass",	0,	0,	1,	0,	0},
	{"Tiger Strike",	254,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Talon",	255,	"ass",	0,	0,	0,	0,	0},
	{"Shock Web",		256,	"ass",	0,	0,	0,	0,	0},
	{"Blade Sentinel",	257,	"ass",	0,	50,	0,	0,	0},
	{"Burst of Speed",	258,	"ass",	0,	0,	1,	1,	0},
	{"Fists of Fire",	259,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Claw",		260,	"ass",	0,	0,	0,	0,	0},
	{"Charged Bolt Sentry",	261,	"ass",	0,	0,	1,	0,	0},
	{"Wake of Fire",	262,	"ass",	0,	0,	1,	0,	0},
	{"Weapon Block",	263,	"ass",	0,	0,	1,	0,	1},
	{"Cloak of Shadows",	264,	"ass",	0,	0,	1,	0,	0},
	{"Cobra Strike",	265,	"ass",	0,	0,	0,	0,	0},
	{"Blade Fury",		266,	"ass",	0,	0,	0,	0,	0},
	{"Fade",			267,	"ass",	0,	0,	1,	1,	0},
	{"Shadow Warrior",	268,	"ass",	0,	0,	1,	1,	0},
	{"Claws of Thunder",	269,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Tail",		270,	"ass",	0,	0,	0,	0,	0},
	{"Lightning Sentry",	271,	"ass",	0,	0,	1,	0,	0},
	{"Wake of Inferno",	272,	"ass",	0,	0,	1,	0,	0},
	{"Mind Blast",		273,	"ass",	0,	0,	1,	0,	0},
	{"Blades of Ice",	274,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Flight",	275,	"ass",	0,	50,	0,	0,	0},
	{"Death Sentry",	276,	"ass",	0,	0,	1,	0,	0},
	{"Blade Shield",	277,	"ass",	0,	0,	1,	1,	0},
	{"Venom",			278,	"ass",	0,	0,	1,	1,	0},
	{"Shadow Master",	279,	"ass",	0,	0,	1,	1,	0},
	{"Phoenix Strike",	280,	"ass",	0,	0,	0,	0,	0}
};